default:
  tags:
    - pipeline

include:
  - 'https://gitlab.com/Linaro/lkft/pipelines/common/-/raw/20210728/common.yml'

variables:
  REVIEW_TO: "ben.copeland@linaro.org"
  REVIEW_CC: "ben.copeland@linaro.org,lkft@linaro.org,ike@fujitsu.com,xdote@fujitsu.com,kazui.kimihiko@fujitsu.com,kato.masaya@fujitsu.com"
  SQUAD_REPORT_CONFIG: "https://gitlab.com/Linaro/lkft/users/ben.copeland/linux-pipeline/-/raw/master/squad-report-config.yml"
  tuxconfig: "https://gitlab.com/Linaro/lkft/users/ben.copeland/linux-pipeline/-/raw/master/tuxconfig.yml"
  default_lava_tests: " --test-plan lkft-ltp lkft-kselftest --test-case kselftests-arm64.yaml kvm-unit-tests.yaml network-basic-tests.yaml fwts.yaml libhugetlbfs.yaml libgpiod.yaml v4l2-compliance.yaml fwts.yaml"
  QA_TEAM: '~ben.copeland'
  QA_SERVER: "https://staging-qa-reports.linaro.org"
  LAVA_SERVER: "http://213.146.155.21/RPC2/"
  LAVA_TEST_PLANS_URL: "https://github.com/bhcopeland/lava-test-plans"

  RUN_TEST: "1"

# This will only build and test branches specified here.
workflow:
  rules:
    - if: '$CI_COMMIT_BRANCH == "linux-5.4.y"'
      when: always
    - if: '$CI_COMMIT_BRANCH == "linux-5.10.y"'
      when: always
    - when: never

# No need to change
stages:
  - download_prerequisites
  - prerequisites
  - build
  - test
  - report
  - review
  - upstream

# Change so it suites you
#########################

# Reporing

report:
  extends:
    - .report
  before_script:
    - export SQUAD_REPORTS="report-full report"

review-report:
  extends: .review
  variables:
    REPORT_TYPE: report
  needs:
    - job: check_project
    - job: download_prerequisites
      artifacts: true
    - job: report
      artifacts: true

# Builds

build-arm64-gcc-11:
  extends:
    - .build
  variables:
    build_set_name: arm64-gcc-11

build-arm64-gcc-11-kasan:
  extends:
    - .build
  variables:
    build_set_name: arm64-gcc-11-kasan

build-arm64-gcc-11-kunit:
  extends:
    - .build
  variables:
    build_set_name: arm64-gcc-11-kunit

build-arm64-gcc-11-64k_page_size:
  extends:
    - .build
  variables:
    build_set_name: arm64-gcc-11-64k_page_size

build-arm-gcc-11:
  extends:
    - .build
  variables:
    build_set_name: arm-gcc-11

build-arm-gcc-11-kasan:
  extends:
    - .build
  variables:
    build_set_name: arm-gcc-11-kasan

build-arm-gcc-11-kunit:
  extends:
    - .build
  variables:
    build_set_name: arm-gcc-11-kunit

# Tests

test-fx700:
  extends:
    - .test
  variables:
    ARCH: arm64
    DEVICE_TYPE: fx700
    LAVA_TESTS: "${default_lava_tests}"
    ROOTFS_URL: "https://storage.lkft.org/rootfs/oe-sumo/20210525/juno/rpb-console-image-lkft-juno-20210525221209.rootfs.tar.xz"
  needs:
    - build-arm64-gcc-11
    - job: download_prerequisites
      artifacts: true
